=== modified file 'Makefile'
--- Makefile	2007-01-30 12:45:50 +0000
+++ Makefile	2006-12-14 17:46:44 +0000
@@ -95,7 +95,7 @@
 # win32 python's distutils-based installer
 # require to have python interpreter installed on win32
 python-installer: docs
-	python setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py" -d .
+	python setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py"
 
 
 # clean on win32 all installer-related files and directories
@@ -107,5 +107,4 @@
 	python tools/win32/ostools.py remove doc/bzr_man.txt
 	python tools/win32/ostools.py remove tools/win32/bzr.iss
 	python tools/win32/ostools.py remove bzr-setup*.exe
-	python tools/win32/ostools.py remove bzr-*win32.exe
 	python tools/win32/ostools.py remove dist

=== modified file 'bzr'
--- bzr	2007-01-24 20:40:20 +0000
+++ bzr	2007-01-16 15:56:53 +0000
@@ -73,14 +73,6 @@
 import bzrlib.lazy_regex
 bzrlib.lazy_regex.install_lazy_compile()
 
-import bzrlib.decorators
-if ('--lsprof' in sys.argv
-    or '--lsprof-file' in sys.argv
-    or '--profile' in sys.argv):
-    bzrlib.decorators.use_pretty_decorators()
-else:
-    bzrlib.decorators.use_fast_decorators()
-
 import bzrlib.commands
 import bzrlib.trace
 

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2007-01-30 12:04:20 +0000
+++ bzrlib/config.py	2006-12-07 16:21:39 +0000
@@ -77,7 +77,6 @@
     osutils,
     symbol_versioning,
     urlutils,
-    win32utils,
     )
 import bzrlib.util.configobj.configobj as configobj
 """)
@@ -710,7 +709,7 @@
     base = os.environ.get('BZR_HOME', None)
     if sys.platform == 'win32':
         if base is None:
-            base = win32utils.get_appdata_location_unicode()
+            base = os.environ.get('APPDATA', None)
         if base is None:
             base = os.environ.get('HOME', None)
         if base is None:
@@ -756,16 +755,7 @@
     """
     import socket
 
-    if sys.platform == 'win32':
-        name = win32utils.get_user_name_unicode()
-        if name is None:
-            raise errors.BzrError("Cannot autodetect user name.\n"
-                                  "Please, set your name with command like:\n"
-                                  'bzr whoami "Your Name <name@domain.com>"')
-        host = win32utils.get_host_name_unicode()
-        if host is None:
-            host = socket.gethostname()
-        return name, (name + '@' + host)
+    # XXX: Any good way to get real user name on win32?
 
     try:
         import pwd

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2007-01-25 15:54:29 +0000
+++ bzrlib/decorators.py	2006-07-28 16:05:23 +0000
@@ -17,98 +17,9 @@
 
 __all__ = ['needs_read_lock',
            'needs_write_lock',
-           'use_fast_decorators',
-           'use_pretty_decorators',
            ]
 
-
-def _get_parameters(func):
-    """Recreate the parameters for a function using introspection.
-
-    :return: (function_params, calling_params)
-        function_params: is a string representing the parameters of the
-            function. (such as "a, b, c=None, d=1")
-            This is used in the function declaration.
-        calling_params: is another string representing how you would call the
-            function with the correct parameters. (such as "a, b, c=c, d=d")
-            Assuming you sued function_params in the function declaration, this
-            is the parameters to put in the function call.
-
-        For example:
-
-        def wrapper(%(function_params)s):
-            return original(%(calling_params)s)
-    """
-    # "import inspect" should stay in local scope. 'inspect' takes a long time
-    # to import the first time. And since we don't always need it, don't import
-    # it globally.
-    import inspect
-    args, varargs, varkw, defaults = inspect.getargspec(func)
-    formatted = inspect.formatargspec(args, varargs=varargs,
-                                      varkw=varkw,
-                                      defaults=defaults)
-    if defaults is None:
-        args_passed = args
-    else:
-        first_default = len(args) - len(defaults)
-        args_passed = args[:first_default]
-        for arg in args[first_default:]:
-            args_passed.append("%s=%s" % (arg, arg))
-    if varargs is not None:
-        args_passed.append('*' + varargs)
-    if varkw is not None:
-        args_passed.append('**' + varkw)
-    args_passed = ', '.join(args_passed)
-
-    return formatted[1:-1], args_passed
-
-
-def _pretty_needs_read_lock(unbound):
-    """Decorate unbound to take out and release a read lock.
-
-    This decorator can be applied to methods of any class with lock_read() and
-    unlock() methods.
-    
-    Typical usage:
-        
-    class Branch(...):
-        @needs_read_lock
-        def branch_method(self, ...):
-            stuff
-    """
-    # This compiles a function with a similar name, but wrapped with
-    # lock_read/unlock calls. We use dynamic creation, because we need the
-    # internal name of the function to be modified so that --lsprof will see
-    # the correct name.
-    # TODO: jam 20070111 Modify this template so that the generated function
-    #       has the same argument signature as the original function, which
-    #       will help commands like epydoc.
-    #       This seems possible by introspecting foo.func_defaults, and
-    #       foo.func_code.co_argcount and foo.func_code.co_varnames
-    template = """\
-def %(name)s_read_locked(%(params)s):
-    self.lock_read()
-    try:
-        return unbound(%(passed_params)s)
-    finally:
-        self.unlock()
-read_locked = %(name)s_read_locked
-"""
-    params, passed_params = _get_parameters(unbound)
-    variables = {'name':unbound.__name__,
-                 'params':params,
-                 'passed_params':passed_params,
-                }
-    func_def = template % variables
-
-    exec func_def in locals()
-
-    read_locked.__doc__ = unbound.__doc__
-    read_locked.__name__ = unbound.__name__
-    return read_locked
-
-
-def _fast_needs_read_lock(unbound):
+def needs_read_lock(unbound):
     """Decorate unbound to take out and release a read lock.
 
     This decorator can be applied to methods of any class with lock_read() and
@@ -132,32 +43,7 @@
     return read_locked
 
 
-def _pretty_needs_write_lock(unbound):
-    """Decorate unbound to take out and release a write lock."""
-    template = """\
-def %(name)s_write_locked(%(params)s):
-    self.lock_write()
-    try:
-        return unbound(%(passed_params)s)
-    finally:
-        self.unlock()
-write_locked = %(name)s_write_locked
-"""
-    params, passed_params = _get_parameters(unbound)
-    variables = {'name':unbound.__name__,
-                 'params':params,
-                 'passed_params':passed_params,
-                }
-    func_def = template % variables
-
-    exec func_def in locals()
-
-    write_locked.__doc__ = unbound.__doc__
-    write_locked.__name__ = unbound.__name__
-    return write_locked
-
-
-def _fast_needs_write_lock(unbound):
+def needs_write_lock(unbound):
     """Decorate unbound to take out and release a write lock."""
     def write_locked(self, *args, **kwargs):
         self.lock_write()
@@ -169,26 +55,3 @@
     write_locked.__name__ = unbound.__name__
     return write_locked
 
-
-# Default is more functionality, 'bzr' the commandline will request fast
-# versions.
-needs_read_lock = _pretty_needs_read_lock
-needs_write_lock = _pretty_needs_write_lock
-
-
-def use_fast_decorators():
-    """Change the default decorators to be fast loading ones.
-
-    The alternative is to have decorators that do more work to produce
-    nice-looking decorated functions, but this slows startup time.
-    """
-    global needs_read_lock, needs_write_lock
-    needs_read_lock = _fast_needs_read_lock
-    needs_write_lock = _fast_needs_write_lock
-
-
-def use_pretty_decorators():
-    """Change the default decorators to be pretty ones."""
-    global needs_read_lock, needs_write_lock
-    needs_read_lock = _pretty_needs_read_lock
-    needs_write_lock = _pretty_needs_write_lock

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2007-01-30 15:18:52 +0000
+++ bzrlib/osutils.py	2007-01-04 23:36:44 +0000
@@ -49,7 +49,6 @@
 
 from bzrlib import (
     errors,
-    win32utils,
     )
 """)
 
@@ -891,7 +890,8 @@
 def terminal_width():
     """Return estimated terminal width."""
     if sys.platform == 'win32':
-        return win32utils.get_console_size()[0]
+        import bzrlib.win32console
+        return bzrlib.win32console.get_console_size()[0]
     width = 0
     try:
         import struct, fcntl, termios

=== removed directory 'bzrlib/repofmt'
=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2007-01-24 11:20:17 +0000
+++ bzrlib/repository.py	2007-01-17 15:37:08 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,7 +37,6 @@
     lockable_files,
     lockdir,
     osutils,
-    registry,
     revision as _mod_revision,
     symbol_versioning,
     transactions,
@@ -1136,15 +1135,6 @@
                                  committer, revprops, revision_id)
 
 
-class RepositoryFormatRegistry(registry.Registry):
-    """Registry of RepositoryFormats.
-    """
-    
-
-format_registry = RepositoryFormatRegistry()
-"""Registry of formats, indexed by their identifying format string."""
-
-
 class RepositoryFormat(object):
     """A repository format.
 
@@ -1169,55 +1159,35 @@
     parameterisation.
     """
 
+    _default_format = None
+    """The default format used for new repositories."""
+
+    _formats = {}
+    """The known formats."""
+
     def __str__(self):
         return "<%s>" % self.__class__.__name__
 
     @classmethod
     def find_format(klass, a_bzrdir):
-        """Return the format for the repository object in a_bzrdir.
-        
-        This is used by bzr native formats that have a "format" file in
-        the repository.  Other methods may be used by different types of 
-        control directory.
-        """
+        """Return the format for the repository object in a_bzrdir."""
         try:
             transport = a_bzrdir.get_repository_transport(None)
             format_string = transport.get("format").read()
-            return format_registry.get(format_string)
+            return klass._formats[format_string]
         except errors.NoSuchFile:
             raise errors.NoRepositoryPresent(a_bzrdir)
         except KeyError:
             raise errors.UnknownFormatError(format=format_string)
 
-    @classmethod
-    @deprecated_method(symbol_versioning.zero_fourteen)
-    def set_default_format(klass, format):
-        klass._set_default_format(format)
-
-    @classmethod
-    def _set_default_format(klass, format):
-        """Set the default format for new Repository creation.
-
-        The format must already be registered.
-        """
-        format_registry.default_key = format.get_format_string()
-
-    @classmethod
-    def register_format(klass, format):
-        format_registry.register(format.get_format_string(), format)
-
-    @classmethod
-    def unregister_format(klass, format):
-        format_registry.remove(format.get_format_string())
+    def _get_control_store(self, repo_transport, control_files):
+        """Return the control store for this repository."""
+        raise NotImplementedError(self._get_control_store)
     
     @classmethod
     def get_default_format(klass):
         """Return the current default format."""
-        return format_registry.get(format_registry.default_key)
-
-    def _get_control_store(self, repo_transport, control_files):
-        """Return the control store for this repository."""
-        raise NotImplementedError(self._get_control_store)
+        return klass._default_format
 
     def get_format_string(self):
         """Return the ASCII format string that identifies this format.
@@ -1305,6 +1275,24 @@
         """
         raise NotImplementedError(self.open)
 
+    @classmethod
+    def register_format(klass, format):
+        klass._formats[format.get_format_string()] = format
+
+    @classmethod
+    @deprecated_method(symbol_versioning.zero_fourteen)
+    def set_default_format(klass, format):
+        klass._set_default_format(format)
+
+    @classmethod
+    def _set_default_format(klass, format):
+        klass._default_format = format
+
+    @classmethod
+    def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
+        del klass._formats[format.get_format_string()]
+
 
 class PreSplitOutRepositoryFormat(RepositoryFormat):
     """Base class for the pre split out repository formats."""
@@ -1819,8 +1807,7 @@
 # formats which have no format string are not discoverable
 # and not independently creatable, so are not registered.
 RepositoryFormat.register_format(RepositoryFormat7())
-# KEEP in sync with bzrdir.format_registry default, which controls the overall
-# default control directory format
+# KEEP in sync with bzrdir.format_registry default
 _default_format = RepositoryFormatKnit1()
 RepositoryFormat.register_format(_default_format)
 RepositoryFormat.register_format(RepositoryFormatKnit2())

=== modified file 'bzrlib/tests/repository_implementations/__init__.py'
--- bzrlib/tests/repository_implementations/__init__.py	2007-01-25 00:35:22 +0000
+++ bzrlib/tests/repository_implementations/__init__.py	2006-10-11 23:08:27 +0000
@@ -1,6 +1,6 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 # Authors: Robert Collins <robert.collins@canonical.com>
-#          and others
+# -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,10 +24,8 @@
 rather than in tests/branch_implementations/*.py.
 """
 
-from bzrlib import (
-    repository,
-    )
 from bzrlib.repository import (_legacy_formats,
+                               RepositoryFormat,
                                RepositoryTestProviderAdapter,
                                )
                             
@@ -49,14 +47,13 @@
         'bzrlib.tests.repository_implementations.test_repository',
         'bzrlib.tests.repository_implementations.test_revision',
         ]
-    all_formats = [v for (k, v) in repository.format_registry.iteritems()]
-    all_formats.extend(_legacy_formats)
     adapter = RepositoryTestProviderAdapter(
         default_transport,
         # None here will cause a readonly decorator to be created
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
-        [(format, format._matchingbzrdir) for format in all_formats])
+        [(format, format._matchingbzrdir) for format in 
+         RepositoryFormat._formats.values() + _legacy_formats])
     loader = TestLoader()
     adapt_modules(test_repository_implementations, adapter, loader, result)
     return result

=== modified file 'bzrlib/tests/test_decorators.py'
--- bzrlib/tests/test_decorators.py	2007-01-24 17:59:50 +0000
+++ bzrlib/tests/test_decorators.py	2006-07-28 16:05:23 +0000
@@ -17,40 +17,20 @@
 
 """Tests for decorator functions"""
 
-import inspect
-
-from bzrlib import decorators
-from bzrlib.decorators import needs_read_lock, needs_write_lock
+from bzrlib.decorators import needs_read_lock
 from bzrlib.tests import TestCase
 
 
 class DecoratorSample(object):
     """Sample class that uses decorators.
 
-    Log when requests go through lock_read()/unlock() or lock_write()/unlock.
+    This doesn't actually work because the class doesn't have the 
+    requiste lock_read()/unlock() methods.
     """
 
-    def __init__(self):
-        self.actions = []
-
-    def lock_read(self):
-        self.actions.append('lock_read')
-
-    def lock_write(self):
-        self.actions.append('lock_write')
-
-    def unlock(self):
-        self.actions.append('unlock')
-
     @needs_read_lock
     def frob(self):
         """Frob the sample object"""
-        self.actions.append('frob')
-
-    @needs_write_lock
-    def bank(self, bar, biz=None):
-        """Bank the sample, but using bar and biz."""
-        self.actions.append(('bank', bar, biz))
 
 
 class TestDecoratorDocs(TestCase):
@@ -59,118 +39,6 @@
     def test_read_lock_passthrough(self):
         """@needs_read_lock exposes underlying name and doc."""
         sam = DecoratorSample()
-        self.assertEqual('frob', sam.frob.__name__)
-        self.assertEqual('Frob the sample object', sam.frob.__doc__)
-
-    def test_write_lock_passthrough(self):
-        """@needs_write_lock exposes underlying name and doc."""
-        sam = DecoratorSample()
-        self.assertEqual('bank', sam.bank.__name__)
-        self.assertEqual('Bank the sample, but using bar and biz.',
-                         sam.bank.__doc__)
-
-    def test_argument_passthrough(self):
-        """Test that arguments get passed around properly."""
-        sam = DecoratorSample()
-        sam.bank('1', biz='2')
-        self.assertEqual(['lock_write',
-                          ('bank', '1', '2'),
-                          'unlock',
-                         ], sam.actions)
-
-
-class TestPrettyDecorators(TestCase):
-    """Test that pretty decorators generate nice looking wrappers."""
-
-    def get_formatted_args(self, func):
-        """Return a nicely formatted string for the arguments to a function.
-
-        This generates something like "(foo, bar=None)".
-        """
-        return inspect.formatargspec(*inspect.getargspec(func))
-
-    def test__pretty_needs_read_lock(self):
-        """Test that _pretty_needs_read_lock generates a nice wrapper."""
-
-        @decorators._pretty_needs_read_lock
-        def my_function(foo, bar, baz=None, biz=1):
-            """Just a function that supplies several arguments."""
-
-        self.assertEqual('my_function', my_function.__name__)
-        self.assertEqual('my_function_read_locked',
-                         my_function.func_code.co_name)
-        self.assertEqual('(foo, bar, baz=None, biz=1)',
-                         self.get_formatted_args(my_function))
-        self.assertEqual('Just a function that supplies several arguments.',
-                         inspect.getdoc(my_function))
-
-    def test__fast_needs_read_lock(self):
-        """Test the output of _fast_needs_read_lock."""
-
-        @decorators._fast_needs_read_lock
-        def my_function(foo, bar, baz=None, biz=1):
-            """Just a function that supplies several arguments."""
-
-        self.assertEqual('my_function', my_function.__name__)
-        self.assertEqual('read_locked', my_function.func_code.co_name)
-        self.assertEqual('(self, *args, **kwargs)',
-                         self.get_formatted_args(my_function))
-        self.assertEqual('Just a function that supplies several arguments.',
-                         inspect.getdoc(my_function))
-
-    def test__pretty_needs_write_lock(self):
-        """Test that _pretty_needs_write_lock generates a nice wrapper."""
-
-        @decorators._pretty_needs_write_lock
-        def my_function(foo, bar, baz=None, biz=1):
-            """Just a function that supplies several arguments."""
-
-        self.assertEqual('my_function', my_function.__name__)
-        self.assertEqual('my_function_write_locked',
-                         my_function.func_code.co_name)
-        self.assertEqual('(foo, bar, baz=None, biz=1)',
-                         self.get_formatted_args(my_function))
-        self.assertEqual('Just a function that supplies several arguments.',
-                         inspect.getdoc(my_function))
-
-    def test__fast_needs_write_lock(self):
-        """Test the output of _fast_needs_write_lock."""
-
-        @decorators._fast_needs_write_lock
-        def my_function(foo, bar, baz=None, biz=1):
-            """Just a function that supplies several arguments."""
-
-        self.assertEqual('my_function', my_function.__name__)
-        self.assertEqual('write_locked', my_function.func_code.co_name)
-        self.assertEqual('(self, *args, **kwargs)',
-                         self.get_formatted_args(my_function))
-        self.assertEqual('Just a function that supplies several arguments.',
-                         inspect.getdoc(my_function))
-
-    def test_use_decorators(self):
-        """Test that you can switch the type of the decorators."""
-        cur_read = decorators.needs_read_lock
-        cur_write = decorators.needs_write_lock
-        try:
-            decorators.use_fast_decorators()
-            self.assertIs(decorators._fast_needs_read_lock,
-                          decorators.needs_read_lock)
-            self.assertIs(decorators._fast_needs_write_lock,
-                          decorators.needs_write_lock)
-
-            decorators.use_pretty_decorators()
-            self.assertIs(decorators._pretty_needs_read_lock,
-                          decorators.needs_read_lock)
-            self.assertIs(decorators._pretty_needs_write_lock,
-                          decorators.needs_write_lock)
-
-            # One more switch to make sure it wasn't just good luck that the
-            # functions pointed to the correct version
-            decorators.use_fast_decorators()
-            self.assertIs(decorators._fast_needs_read_lock,
-                          decorators.needs_read_lock)
-            self.assertIs(decorators._fast_needs_write_lock,
-                          decorators.needs_write_lock)
-        finally:
-            decorators.needs_read_lock = cur_read
-            decorators.needs_write_lock = cur_write
+        self.assertEqual(sam.frob.__name__, 'frob')
+        self.assertEqual(sam.frob.__doc__, 
+                'Frob the sample object')

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2007-01-24 07:12:09 +0000
+++ bzrlib/tests/test_repository.py	2007-01-05 06:32:57 +0000
@@ -34,40 +34,33 @@
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
-from bzrlib.repository import RepositoryFormat
+import bzrlib.repository as repository
 from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryServer
-from bzrlib import (
-    repository,
-    upgrade,
-    workingtree,
-    )
+from bzrlib import upgrade, workingtree
 
 
 class TestDefaultFormat(TestCase):
 
     def test_get_set_default_format(self):
-        old_format = RepositoryFormat.get_default_format()
-        test_format = SampleRepositoryFormat()
-        RepositoryFormat.register_format(test_format)
+        private_default = repository._default_format.__class__
+        old_format = repository.RepositoryFormat.get_default_format()
+        self.assertTrue(isinstance(old_format, private_default))
+        self.applyDeprecated(symbol_versioning.zero_fourteen, 
+            repository.RepositoryFormat.set_default_format, 
+            SampleRepositoryFormat())
+        # creating a repository should now create an instrumented dir.
         try:
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
+            result = dir.create_repository()
+            self.assertEqual(result, 'A bzr repository dir')
+        finally:
             self.applyDeprecated(symbol_versioning.zero_fourteen, 
-                RepositoryFormat.set_default_format, 
-                test_format)
-            # creating a repository should now create an instrumented dir.
-            try:
-                # the default branch format is used by the meta dir format
-                # which is not the default bzrdir format at this point
-                dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
-                result = dir.create_repository()
-                self.assertEqual(result, 'A bzr repository dir')
-            finally:
-                self.applyDeprecated(symbol_versioning.zero_fourteen,
-                    RepositoryFormat.set_default_format, old_format)
-        finally:
-            RepositoryFormat.unregister_format(test_format)
-        self.assertEqual(old_format, RepositoryFormat.get_default_format())
+                repository.RepositoryFormat.set_default_format, old_format)
+        self.assertEqual(old_format, repository.RepositoryFormat.get_default_format())
 
 
 class SampleRepositoryFormat(repository.RepositoryFormat):

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2007-01-30 10:51:38 +0000
+++ bzrlib/trace.py	2007-01-18 18:22:01 +0000
@@ -137,32 +137,22 @@
         return
 
 
-def open_tracefile(tracefilename=None):
+def open_tracefile(tracefilename='~/.bzr.log'):
     # Messages are always written to here, so that we have some
     # information if something goes wrong.  In a future version this
     # file will be removed on successful completion.
     global _file_handler, _bzr_log_file
     import codecs
 
-    if tracefilename is None:
-        if sys.platform == 'win32':
-            from bzrlib import win32utils
-            home = win32utils.get_home_location()
-        else:
-            home = os.path.expanduser('~')
-        tracefilename = os.path.join(home, '.bzr.log')
-
-    trace_fname = os.path.expanduser(tracefilename)
+    trace_fname = os.path.join(os.path.expanduser(tracefilename))
     _rollover_trace_maybe(trace_fname)
     try:
         LINE_BUFFERED = 1
         #tf = codecs.open(trace_fname, 'at', 'utf8', buffering=LINE_BUFFERED)
         tf = open(trace_fname, 'at', LINE_BUFFERED)
         _bzr_log_file = tf
-        # tf.tell() on windows always return 0 until some writing done
-        tf.write('\n')
-        if tf.tell() <= 2:
-            tf.write("this is a debug log for diagnosing/reporting problems in bzr\n")
+        if tf.tell() == 0:
+            tf.write("\nthis is a debug log for diagnosing/reporting problems in bzr\n")
             tf.write("you can delete or truncate this file, or include sections in\n")
             tf.write("bug reports to bazaar@lists.canonical.com\n\n")
         _file_handler = logging.StreamHandler(tf)

=== renamed file 'bzrlib/win32utils.py' => 'bzrlib/win32console.py'
--- bzrlib/win32utils.py	2007-01-30 10:50:14 +0000
+++ bzrlib/win32console.py	2006-10-05 05:37:25 +0000
@@ -1,6 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
-#
-# Author: Alexander Belchenko
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,213 +14,52 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Win32-specific helper functions
-
-Only one dependency: ctypes should be installed.
-"""
-
-import os
+
+"""
+Set of functions to work with console on Windows.
+Author: Alexander Belchenko (e-mail: bialix AT ukr.net)
+License: Public domain
+"""
+
 import struct
-import sys
-
-
-# Windows version
-if sys.platform == 'win32':
-    _major,_minor,_build,_platform,_text = sys.getwindowsversion()
-    if _platform == 0:
-        raise Exception('This platform does not supported!')
-    elif _platform == 1:
-        winver = 'Windows 98'
-    else:
-        winver = 'Windows NT'
-else:
-    winver = None
-
 
 # We can cope without it; use a separate variable to help pyflakes
 try:
-    import ctypes
-    has_ctypes = True
+   import ctypes
+   has_ctypes = True
 except ImportError:
     has_ctypes = False
-else:
-    if winver == 'Windows 98':
-        create_buffer = ctypes.create_string_buffer
-        suffix = 'A'
-    else:
-        create_buffer = ctypes.create_unicode_buffer
-        suffix = 'W'
-
-
-# Special Win32 API constants
-# Handles of std streams
+
+
 WIN32_STDIN_HANDLE = -10
 WIN32_STDOUT_HANDLE = -11
 WIN32_STDERR_HANDLE = -12
 
-# CSIDL constants (from MSDN 2003)
-CSIDL_APPDATA = 0x001A      # Application Data folder
-CSIDL_PERSONAL = 0x0005     # My Documents folder
-
-# from winapi C headers
-MAX_PATH = 260
-UNLEN = 256
-MAX_COMPUTERNAME_LENGTH = 31
-
 
 def get_console_size(defaultx=80, defaulty=25):
-    """Return size of current console.
-
-    This function try to determine actual size of current working
-    console window and return tuple (sizex, sizey) if success,
-    or default size (defaultx, defaulty) otherwise.
-    """
-    if not has_ctypes:
-        # no ctypes is found
-        return (defaultx, defaulty)
-
-    # To avoid problem with redirecting output via pipe
-    # need to use stderr instead of stdout
-    h = ctypes.windll.kernel32.GetStdHandle(WIN32_STDERR_HANDLE)
-    csbi = ctypes.create_string_buffer(22)
-    res = ctypes.windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
-
-    if res:
-        (bufx, bufy, curx, cury, wattr,
+   """ Return size of current console.
+
+   This function try to determine actual size of current working
+   console window and return tuple (sizex, sizey) if success,
+   or default size (defaultx, defaulty) otherwise.
+
+   Dependencies: ctypes should be installed.
+   """
+   if not has_ctypes:
+       # no ctypes is found
+       return (defaultx, defaulty)
+
+   # To avoid problem with redirecting output via pipe
+   # need to use stderr instead of stdout
+   h = ctypes.windll.kernel32.GetStdHandle(WIN32_STDERR_HANDLE)
+   csbi = ctypes.create_string_buffer(22)
+   res = ctypes.windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
+
+   if res:
+       (bufx, bufy, curx, cury, wattr,
         left, top, right, bottom, maxx, maxy) = struct.unpack("hhhhHhhhhhh", csbi.raw)
-        sizex = right - left + 1
-        sizey = bottom - top + 1
-        return (sizex, sizey)
-    else:
-        return (defaultx, defaulty)
-
-
-def get_appdata_location():
-    """Return Application Data location.
-    Return None if we cannot obtain location.
-
-    Returned value can be unicode or plain sring.
-    To convert plain string to unicode use
-    s.decode(bzrlib.user_encoding)
-    """
-    if has_ctypes:
-        try:
-            SHGetSpecialFolderPath = \
-                ctypes.windll.shell32.SHGetSpecialFolderPathW
-        except AttributeError:
-            pass
-        else:
-            buf = ctypes.create_unicode_buffer(MAX_PATH)
-            if SHGetSpecialFolderPath(None,buf,CSIDL_APPDATA,0):
-                return buf.value
-    # from env variable
-    appdata = os.environ.get('APPDATA')
-    if appdata:
-        return appdata
-    # if we fall to this point we on win98
-    # at least try C:/WINDOWS/Application Data
-    windir = os.environ.get('windir')
-    if windir:
-        appdata = os.path.join(windir, 'Application Data')
-        if os.path.isdir(appdata):
-            return appdata
-    # did not find anything
-    return None
-
-
-def get_home_location():
-    """Return user's home location.
-    Assume on win32 it's the <My Documents> folder.
-    If location cannot be obtained return system drive root,
-    i.e. C:\
-
-    Returned value can be unicode or plain sring.
-    To convert plain string to unicode use
-    s.decode(bzrlib.user_encoding)
-    """
-    if has_ctypes:
-        try:
-            SHGetSpecialFolderPath = \
-                ctypes.windll.shell32.SHGetSpecialFolderPathW
-        except AttributeError:
-            pass
-        else:
-            buf = ctypes.create_unicode_buffer(MAX_PATH)
-            if SHGetSpecialFolderPath(None,buf,CSIDL_PERSONAL,0):
-                return buf.value
-    # try for HOME env variable
-    home = os.path.expanduser('~')
-    if home != '~':
-        return home
-    # at least return windows root directory
-    windir = os.environ.get('windir')
-    if windir:
-        return os.path.splitdrive(windir) + '/'
-    # otherwise C:\ is good enough for 98% users
-    return 'C:/'
-
-
-def get_user_name():
-    """Return user name as login name.
-    If name cannot be obtained return None.
-
-    Returned value can be unicode or plain sring.
-    To convert plain string to unicode use
-    s.decode(bzrlib.user_encoding)
-    """
-    if has_ctypes:
-        try:
-            advapi32 = ctypes.windll.advapi32
-            GetUserName = getattr(advapi32, 'GetUserName'+suffix)
-        except AttributeError:
-            pass
-        else:
-            buf = create_buffer(UNLEN+1)
-            n = ctypes.c_int(UNLEN+1)
-            if GetUserName(buf, ctypes.byref(n)):
-                return buf.value
-    # otherwise try env variables
-    return os.environ.get('USERNAME', None)
-
-
-def get_host_name():
-    """Return host machine name.
-    If name cannot be obtained return None.
-
-    Returned value can be unicode or plain sring.
-    To convert plain string to unicode use
-    s.decode(bzrlib.user_encoding)
-    """
-    if has_ctypes:
-        try:
-            kernel32 = ctypes.windll.kernel32
-            GetComputerName = getattr(kernel32, 'GetComputerName'+suffix)
-        except AttributeError:
-            pass
-        else:
-            buf = create_buffer(MAX_COMPUTERNAME_LENGTH+1)
-            n = ctypes.c_int(MAX_COMPUTERNAME_LENGTH+1)
-            if GetComputerName(buf, ctypes.byref(n)):
-                return buf.value
-    # otherwise try env variables
-    return os.environ.get('COMPUTERNAME', None)
-
-
-def _ensure_unicode(s):
-    if s and type(s) != unicode:
-        import bzrlib
-        s = s.decode(bzrlib.user_encoding)
-    return s
-    
-
-def get_appdata_location_unicode():
-    return _ensure_unicode(get_appdata_location())
-
-def get_home_location_unicode():
-    return _ensure_unicode(get_home_location())
-
-def get_user_name_unicode():
-    return _ensure_unicode(get_user_name())
-
-def get_host_name_unicode():
-    return _ensure_unicode(get_host_name())
+       sizex = right - left + 1
+       sizey = bottom - top + 1
+       return (sizex, sizey)
+   else:
+       return (defaultx, defaulty)

=== modified file 'setup.py'
--- setup.py	2007-01-30 12:13:18 +0000
+++ setup.py	2007-01-18 18:37:21 +0000
@@ -99,6 +99,9 @@
     Create bzr.bat for win32.
     """
     def run(self):
+        import os
+        import sys
+
         install_scripts.run(self)   # standard action
 
         if sys.platform == "win32":
@@ -124,8 +127,7 @@
             return path
 
     def _win_batch_args(self):
-        from bzrlib.win32utils import winver
-        if winver == 'Windows NT':
+        if os.name == 'nt':
             return '%*'
         else:
             return '%1 %2 %3 %4 %5 %6 %7 %8 %9'

=== modified file 'tools/win32/bzr-win32-bdist-postinstall.py'
--- tools/win32/bzr-win32-bdist-postinstall.py	2007-01-30 12:45:50 +0000
+++ tools/win32/bzr-win32-bdist-postinstall.py	2006-12-14 17:46:44 +0000
@@ -16,14 +16,11 @@
 # [bialix]: bzr de-facto does not support win98.
 #           Although it seems to work on. Sometimes.
 # 2006/07/30    added minimal support of win98.
-# 2007/01/30    added *real* support of win98.
 
 import os
 import sys
 import _winreg
 
-from bzrlib import win32utils
-
 
 def _quoted_path(path):
     if ' ' in path:
@@ -32,7 +29,7 @@
         return path
 
 def _win_batch_args():
-    if win32utils.winver == 'Windows NT':
+    if os.name == 'nt':
         return '%*'
     else:
         return '%1 %2 %3 %4 %5 %6 %7 %8 %9'
@@ -65,16 +62,24 @@
         python_path = _quoted_path(os.path.join(prefix, "python.exe"))
         args = _win_batch_args()
         batch_str = "@%s %s %s" % (python_path, script_path, args)
-        # support of win98
-        # if there is no HOME for bzr then set it for Bazaar manually
-        base = os.environ.get('BZR_HOME', None)
-        if base is None:
-            base = win32utils.get_appdata_location()
-        if base is None:
-            base = os.environ.get('HOME', None)
-        if base is None:
-            base = os.path.splitdrive(sys.prefix)[0] + '\\'
-            batch_str = ("@SET BZR_HOME=" + _quoted_path(base) + "\n" +
+        # minimal support of win98
+        # if there is no HOME in system then set it for Bazaar manually
+        homes = ('BZR_HOME', 'APPDATA', 'HOME')
+        for home in homes:
+            bzr_home = os.environ.get(home, None)
+            if bzr_home is not None:
+                break
+        else:
+            try:
+                bzr_home = get_special_folder('CSIDL_APPDATA')
+            except OSError:
+                # no Application Data
+                bzr_home = ''
+
+            if not bzr_home:
+                bzr_home = os.path.splitdrive(sys.prefix)[0] + '\\'
+
+            batch_str = ("@SET BZR_HOME=" + _quoted_path(bzr_home) + "\n" +
                          batch_str)
 
         batch_path = os.path.join(scripts_dir, "bzr.bat")
@@ -90,6 +95,20 @@
     except Exception, e:
         print "ERROR: Unable to create %s: %s" % (batch_path, e)
 
+    # make entry in bzr home directory
+    dst = os.path.join(bzr_home, "bazaar", "2.0")
+    if not os.path.isdir(dst):
+        os.makedirs(dst)
+        import locale
+        print "Configuration files stored in %s" % \
+              dst.encode(locale.getpreferredencoding(), 'replace')
+        # create dummy bazaar.conf
+        f = file(os.path.join(dst,'bazaar.conf'), 'w')
+        f.write("# main configuration file of Bazaar\n"
+                "[DEFAULT]\n"
+                "#email=Your Name <you@domain.com>\n")
+        f.close()
+
     ## this hunk borrowed from pywin32_postinstall.py
     # use bdist_wininst builtins to create a shortcut.
     # CSIDL_COMMON_PROGRAMS only available works on NT/2000/XP, and

=== modified file 'tools/win32/bzr.iss.cog'
--- tools/win32/bzr.iss.cog	2007-01-30 23:05:35 +0000
+++ tools/win32/bzr.iss.cog	2007-01-13 20:00:38 +0000
@@ -44,7 +44,7 @@
 InfoBeforeFile="..\tools\win32\info.txt"
 
 VersionInfoCompany="Canonical Ltd."
-VersionInfoCopyright="Canonical Ltd., 2005-2007"
+VersionInfoCopyright="Canonical Ltd., 2005-2006"
 VersionInfoDescription="Installer for stand-alone bzr.exe"
 ; [[[cog
 ; import bzrlib
@@ -90,7 +90,7 @@
 [Icons]
 Name: "{group}\Documentation index"; Filename: "{app}\doc\index.htm"; WorkingDir: "{app}\doc";
 Name: "{group}\Bazaar Home Page"; Filename: "{app}\bazaar.url"; Comment: "http://www.bazaar-vcs.org";
-Name: "{group}\Start Bzr in cmd shell"; Filename: "%COMSPEC%"; Parameters: "/K start_bzr.bat"; WorkingDir: "{app}"; IconFilename: "{app}\bzr.exe"; Comment: "Open new Bzr session";
+Name: "{group}\Start Bzr in cmd shell"; Filename: "{sys}\cmd.exe"; Parameters: "/K start_bzr.bat"; WorkingDir: "{app}"; IconFilename: "{app}\bzr.exe"; Comment: "Open new Bzr session";
 Name: "{group}\Uninstall Bzr"; Filename: "{uninstallexe}"; IconFileName: "{sys}\shell32.dll"; IconIndex: 101; Comment: "Remove Bzr completely";
 
 [Tasks]

=== modified file 'tools/win32/bzr_postinstall.py'
--- tools/win32/bzr_postinstall.py	2007-01-30 23:05:35 +0000
+++ tools/win32/bzr_postinstall.py	2006-06-29 08:41:31 +0000
@@ -19,14 +19,13 @@
 """
 
 import os
-import shutil
 import sys
 
 
 ##
 # CONSTANTS
 
-VERSION = "1.4.20070130"
+VERSION = "1.3.20060513"
 
 USAGE = """Bzr postinstall helper for win32 installation
 Usage: %s [options]
@@ -46,16 +45,6 @@
     --check-mfc71               - check if MFC71.DLL present in system
 """ % os.path.basename(sys.argv[0])
 
-# Windows version
-_major,_minor,_build,_platform,_text = sys.getwindowsversion()
-if _platform == 0:
-    raise Exception('This platform does not supported!')
-elif _platform == 1:
-    winver = 'Windows 98'
-else:
-    winver = 'Windows NT'
-
-
 ##
 # INTERNAL VARIABLES
 
@@ -166,7 +155,7 @@
             f.write(''.join(content))
             f.close()
 
-    if (add_path or delete_path) and winver == 'Windows NT':
+    if add_path or delete_path:
         # find appropriate registry key:
         # 1. HKLM\System\CurrentControlSet\Control\SessionManager\Environment
         # 2. HKCU\Environment
@@ -224,55 +213,6 @@
         if not hkey is None:
             _winreg.CloseKey(hkey)
 
-    if (add_path or delete_path) and winver == 'Windows 98':
-        # mutating autoexec.bat
-        # adding or delete string:
-        # SET PATH=%PATH%;C:\PROGRA~1\Bazaar
-        cur_path = os.environ.get('PATH')
-        if cur_path.find(bzr_dir) != -1:
-            bzr_dir_in_path = True
-        else:
-            bzr_dir_in_path = False
-
-        abat = 'C:\\autoexec.bat'
-        abak = 'C:\\autoexec.bak'
-
-        def backup_autoexec_bat(name, backupname, dry_run):
-            # backup autoexec.bat
-            if os.path.isfile(name):
-                if not dry_run:
-                    shutil.copyfile(name, backupname)
-                else:
-                    print '*** backup copy of autoexec.bat created'
-
-        if delete_path and bzr_dir_in_path:
-            backup_autoexec_bat(abat, abak, dry_run)
-            f = file(abat, 'r')
-            lines = f.readlines()
-            f.close()
-
-            pattern = 'SET PATH=%PATH%;' + bzr_dir
-            if not dry_run:
-                f = file(abat, 'w')
-                for i in lines:
-                    if i.rstrip('\r\n') != pattern:
-                        f.write(i)
-                f.close()
-            else:
-                print '*** Remove line <%s> from autoexec.bat' % pattern
-                    
-        elif add_path and not bzr_dir_in_path:
-            backup_autoexec_bat(abat, abak, dry_run)
-
-            pattern = 'SET PATH=%PATH%;' + bzr_dir
-            if not dry_run:
-                f = file(abat, 'a')
-                f.write(pattern)
-                f.write('\n')
-                f.close()
-            else:
-                print '*** Add line <%s> to autoexec.bat' % pattern
-
     if add_shell_menu and not delete_shell_menu:
         hkey = None
         try:
@@ -289,9 +229,8 @@
             _winreg.SetValue(hkey, '', _winreg.REG_SZ, 'Bzr Here')
             hkey2 = _winreg.CreateKey(hkey, 'command')
             _winreg.SetValue(hkey2, '', _winreg.REG_SZ,
-                             '%s /K "%s"' % (
-                                    os.environ.get('COMSPEC', '%COMSPEC%'),
-                                    os.path.join(bzr_dir, 'start_bzr.bat'))
+                             'cmd /K "%s"' % os.path.join(bzr_dir,
+                                                          'start_bzr.bat'))
             _winreg.CloseKey(hkey2)
             _winreg.CloseKey(hkey)
 

=== modified file 'tools/win32/start_bzr.bat'
--- tools/win32/start_bzr.bat	2007-01-30 23:05:35 +0000
+++ tools/win32/start_bzr.bat	2006-07-30 06:52:39 +0000
@@ -27,5 +27,5 @@
 
 REM --------------------------------------------------------------------------
 
+bzr.exe help
 @ECHO ON
-@bzr.exe help
\ No newline at end of file

